﻿/***************************************************************   
 * Copyright (c) 2012, Sportradar AG                           *
 ***************************************************************/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Data;
using Sportradar.Demo.GUI.LiveOdds.DataProvider.Common;
using Sportradar.Demo.GUI.LiveOdds.DataProvider.Models;
using System.Collections.ObjectModel;
using Sportradar.Demo.GUI.LiveOdds.DataProvider;

namespace Sportradar.Demo.GUI.LiveOdds.Code
{
    public class MatchIdToMatchOddsConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter,
            System.Globalization.CultureInfo culture)
        {
            if ((value != null) && (value is long))
            {
                long matchId = (long)value;

                ImprovedObservableCollection<MatchOddsModel> matchOdds;
                if (References.Instance.MatchOdds.TryGetValue(matchId, out matchOdds))
                {
                    return matchOdds.Where(x=>x.Active==true);
                }
            }

            return value;
        }

        public object ConvertBack(object value, Type targetType, object parameter,
            System.Globalization.CultureInfo culture)
        {
            throw new NotSupportedException();
        }
    }
}
