﻿/***************************************************************   
 * Copyright (c) 2012, Sportradar AG                           *
 ***************************************************************/

using System;
using System.Windows.Data;

namespace Sportradar.Demo.GUI.LiveOdds.Code
{
    public class TimeSpanToMillisConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value != null)
            {
                if (value is TimeSpan)
                {
                    return String.Format("{0:0.0}", ((TimeSpan)value).TotalMilliseconds);
                }
                else if (value is TimeSpan? && ((TimeSpan?)value).HasValue)
                {
                    return String.Format("{0:0.0}", ((TimeSpan?)value).Value.TotalMilliseconds);
                }
            }

            return value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotSupportedException();
        }
    }
}
